<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content="">
    <meta name="author" content="">
    <!--link rel="icon" href="../../../../favicon.ico"-->

    <title>MAMS Vickrey Auction</title>

    <!-- Bootstrap core CSS -->
    <script src="https://code.jquery.com/jquery-3.3.1.js"></script>

    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" type="text/css" />
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>


    <link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-dialog/1.34.7/css/bootstrap-dialog.min.css" rel="stylesheet" type="text/css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-dialog/1.34.7/js/bootstrap-dialog.min.js"></script>

    <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="text-center">
<nav class="navbar navbar-default">
    <a class="navbar-brand" href="#">MAMS Vickrey Auction</a>
</nav>
<div class="container">
    <div class="row mb-2">
        <div class="col-md-6">
            <h3>Items Available</h3>
            <div class="card flex-md-row mb-4 shadow-sm h-md-250">
                <table id="items" class="table table-striped">
                    <thead>
                    <tr>
                        <th>Item</th>
                        <th>Quantity</th>
                        <th>Reserve</th>
                        <th>State</th>
                        <th><button class="btn btn-danger" onclick="add_item()">Add</button></th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
        <div class="col-md-6">
            <h3>Clients Active</h3>
            <div class="card flex-md-row mb-4 shadow-sm h-md-250">
                <table id="clients" class="table table-striped">
                    <thead>
                    <tr>
                        <th>Id</th>
                        <th>Notification Url</th>
                        <th><button class="btn btn-danger" onclick="add_client()">Add</button></th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</div>
</body>
<script type="text/javascript">
    ACTIVE = true;

	$(document).ready(function() {
		refresh();
	});

    function stop_it() {
        $("#stop").addClass("disabled");
        ACTIVE = false;
    }

	function refresh() {
	    $.get({
            type:"GET",
            dataType: "json",
            url: $(location).attr("href")+"../manager/items",
            success: function(response) {
                $("#items tbody").empty();
                for(i=0;i<response.length;i++) {
                    item = response[i];
                    $("#items tbody").append("<tr><td>"+item.item+"</td><td>"+item.quantity+"</td><td>"+ item.reserve+"</td><td>"+item.state+"</td></tr>");
                }
            },
            error: function(xhr, a,b) {
                console.log(a);
                console.log(b);
            }
	    });

	    $.ajax({
            type: "GET",
            url: $(location).attr("href")+"../manager/clients",
            success: function(response) {
                $("#clients tbody").empty();
                for(i=0;i<response.length;i++) {
                    client = response[i];
                    $("#clients tbody").append("<tr><td>"+client.id+"</td><td>"+client.notificationUrl+"</td></tr>");
                }
            },
            dataType: "json"
        });

        if (ACTIVE) {
            setTimeout(function() {
                refresh();
            }, 10000);
        }
	}

    function add_item() {
        BootstrapDialog.show({
            title: 'Add Item',
            message: $('<div></div>').load("addItem.html"),
            buttons: [{
                label: 'Cancel',
                action: function(dialog) {
                    dialog.close();
                }
            }, {
                label: 'Add',
                action: function(dialog) {
                    dialog.close();
                    data = {
                        item : $("#item").val(),
                        quantity : $("#quantity").val(),
                        reserve : $("#reserve").val()
                    };

                    $.ajax({
                        type: "POST",
                        url: "/manager/items",
                        data: JSON.stringify(data),
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        success: function(data){
                            console.log(data);
                        }, failure: function(errMsg) {
                            alert(errMsg);
                        }
                    });
                }
            }]
        });
    }

    function add_client() {
        BootstrapDialog.show({
            title: 'Add Client',
            message: $('<div></div>').load("addClient.html"),
            buttons: [{
                label: 'Cancel',
                action: function(dialog) {
                    dialog.close();
                }
            }, {
                label: 'Add',
                action: function(dialog) {
                    dialog.close();
                    data = {
                        item : $("#item").val(),
                        quantity : $("#quantity").val(),
                        reserve : $("#reserve").val()
                    };

                    $.ajax({
                        type: "POST",
                        url: "/manager/items",
                        data: JSON.stringify(data),
                        contentType: "application/json; charset=utf-8",
                        dataType: "json",
                        success: function(data){
                            console.log(data);
                        }, failure: function(errMsg) {
                            alert(errMsg);
                        }
                    });
                }
            }]
        });
    }
    </script>
</html>